# -*- coding: UTF-8 -*-

import wx

from outwiker.core.pluginbase import Plugin
from outwiker.core.commands import getCurrentVersion, MessageBox
from outwiker.core.version import Version


__version__ = u"0.0.1"

if getCurrentVersion() < Version (1, 8, 0, 742):
    print ("MyFirstPlugin. OutWiker version requirement: 1.8.0.742")
else:
    class PluginMyFirst (Plugin):
        """
        Простейший плагин
        """
        def __init__ (self, application):
            super (PluginMyFirst, self).__init__ (application)
            self.ID_HELLO = wx.NewId()
            self._menu = None


        @property
        def name (self):
            return u"MyFirstPlugin"


        @property
        def description (self):
            return u'''This is a first plugin'''


        @property
        def url (self):
            return u"http://example.com"


        @property
        def version (self):
            return __version__


        def initialize (self):
            # Проверим, что главное окно создано
            if self._application.mainWindow is not None:
                # Создадим меню "MyFirstPlugin" с единственным пунктом - "Hello"
                self._menu = wx.Menu()
                self._menu.Append (self.ID_HELLO, u"Hello")
                self._application.mainWindow.Bind (wx.EVT_MENU, self._onHello, id = self.ID_HELLO)

                self._application.mainWindow.mainMenu.Insert (0, self._menu, u"MyFirstPlugin")


        def destroy (self):
            # Проверим, что главное окно создано
            if self._application.mainWindow is not None:
                # Найдем позицию нашего меню и удалим его
                pos = self._application.mainWindow.mainMenu.FindMenu (self._menu.GetTitle())
                if pos != wx.NOT_FOUND:
                    self._application.mainWindow.mainMenu.Remove (pos)


        def _onHello (self, event):
            """
            Действие на выбор пункта меню "Hello"
            """
            MessageBox (u"Hello world",
                        u"Hello",
                        wx.OK)
